web/router.ex
defmodule BachelorThesis.Router do
  use BachelorThesis.Web, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
  end

  pipeline :authentication do
    plug BachelorThesis.Plug.Authenticate
  end

  pipeline :api do
    plug :accepts, ["json"]
  end

  scope "/", BachelorThesis do
    pipe_through :browser # Use the default browser stack

    get "/", PageController, :index

    resources "/users", UserController, only: [:create, :new]

    # login session
    post "/login", SessionController, :create
    delete "/logout", SessionController, :delete

    # pair up device by token
    get "/pairUpDevice/:token", DeviceController, :pairUpDeviceByToken
    get "/pairUpSmartDevice/:token", SmartDeviceController, :pairUpSmartDeviceByToken

    # control device by smart device
    get "/setDeviceAction/:device_token/:smart_device_token/:interface_type_shortcut/:value", DeviceActionController, :setAction
    # device info
    get "/setDeviceValue/:device_token/:interface_type_shortcut/:value", DeviceValueController, :setValue
    # confirm device action
    get "/confirmAction/:device_token/:action_id", DeviceActionController, :confirmAction
    # device info
    get "/getDeviceValue/:device_token", DeviceValueController, :getValue
    get "/getDeviceAction/:device_token", DeviceActionController, :getAction
    end

  scope "/", BachelorThesis do
    pipe_through [:browser, :authentication]

    resources "/users", UserController, except: [:create, :new, :index] do
      # smart_devices
      resources "/smart_devices", SmartDeviceController
      post "/smart_device/:smart_device_id/pair", SmartDeviceController, :pairDevice
      delete "/smart_device/:smart_device_id/delete/:id", SmartDeviceController, :deletePairDevice
      post "/smart_device/:smart_device_id/unpairSmartDevice/", SmartDeviceController, :unpairSmartDevice
      post "/smart_device/:smart_device_id/activateSmartDevice/:action", SmartDeviceController, :activateSmartDevice

      # devices
      resources "/devices", DeviceController
      post "/device/:device_id/pair", DeviceController, :pairDevice
      delete "/device/:device_id/delete/:id", DeviceController, :deletePairDevice
      post "/device/:device_id/unpairDevice/", DeviceController, :unpairDevice
      post "/device/:device_id/activateDevice/:action", DeviceController, :activateDevice
    end
  end

  # Other scopes may use custom stacks.
  # scope "/api", BachelorThesis do
  #   pipe_through :api
  # end

  scope "/graphql" do
    pipe_through :api

    # Welcome API
    get "/api", BachelorThesis.PageController, :api
    post "/api", BachelorThesis.PageController, :api_post

    get "/device", GraphQL.Plug, schema: {GraphQL.Schema.DeviceSchema, :schema}
    post "/device", GraphQL.Plug, schema: {GraphQL.Schema.DeviceSchema, :schema}
  end
end

web/models/user.ex
defmodule BachelorThesis.User do
  use BachelorThesis.Web, :model

  alias BachelorThesis.Repo
  alias BachelorThesis.User

  schema "users" do
    field :email, :string
    field :password, :string
    field :firstName, :string
    field :lastName, :string
    field :admin, :boolean, default: false

    has_many :smart_devices, BachelorThesis.SmartDevice, on_delete: :delete_all
    many_to_many :devices, BachelorThesis.Device, join_through: BachelorThesis.UserDevice, on_delete: :delete_all

    timestamps()
  end

  @doc """
  Builds a changeset based on the `struct` and `params`.
  """
  def changeset(struct, params \\ %{}) do
    struct
    |> cast(params, [:email, :password, :firstName, :lastName, :admin])
    |> validate_required([:email, :password, :firstName, :lastName, :admin])
    |> unique_constraint(:email)
  end

  @doc """
  Function returns User by email and password
  """
  def get_by_email_password(email, password, preload) do
    query = from u in User,
      where: u.email == ^email and u.password == ^password
    # this could break if more than theres more than 1 user with same name.
    user = Repo.one(query)
    case user do
      nil -> nil
      _ -> get_by_id(user.id, preload)
    end
  end

  @doc """
  Function returns SmartDevice by selected id.
  Parameter preload is used to decide if returned user contains preloaded smart devices and devices.
  """
  def get_by_id(id, preload) do
    case preload do
      true -> Repo.get(User, id) |> Repo.preload([:smart_devices, :devices])
      _    -> Repo.get(User, id)
    end

  end
end

web/controllers/user_controller.ex
defmodule BachelorThesis.UserController do
  use BachelorThesis.Web, :controller

  alias BachelorThesis.User
  alias BachelorThesis.Hash
  alias BachelorThesis.Session
  import Ecto.Changeset, only: [put_change: 3]

  def index(conn, _params) do
    users = Repo.all(User)
    render(conn, "index.html", users: users)
  end

  def new(conn, _params) do
    changeset = User.changeset(%User{})
    render(conn, "new.html", changeset: changeset)
  end

  def create(conn, %{"user" => user_params}) do
    changeset = User.changeset(%User{}, user_params) |> put_change(:password, Hash.hashString(user_params["password"]))

    case Repo.insert(changeset) do
      {:ok, _user} ->
        conn
          |> put_flash(:info, "User created successfully.")
          |> Session.login(user_params)
          |> redirect(to: page_path(conn, :index))
      {:error, err_changeset} ->
        render(conn, "new.html", changeset: err_changeset)
    end
  end

  def show(conn, %{"id" => id}) do
    user = User.get_by_id(id, true)
    conn |> validation(user)
    render(conn, "show.html", user: user)
  end

  def edit(conn, %{"id" => id}) do
    user = Repo.get!(User, id)
    changeset = User.changeset(user)
    render(conn, "edit.html", user: user, changeset: changeset)
  end

  def update(conn, %{"id" => id, "user" => user_params}) do
    user = Repo.get!(User, id)
    changeset = User.changeset(user, user_params)

    case Repo.update(changeset) do
      {:ok, user} ->
        conn
          |> put_flash(:info, "User updated successfully.")
          |> redirect(to: user_path(conn, :show, user))
      {:error, changeset} ->
        render(conn, "edit.html", user: user, changeset: changeset)
    end
  end

  def delete(conn, %{"id" => id}) do
    user = Repo.get!(User, id)

    # Here we use delete! (with a bang) because we expect
    # it to always work (and if it does not, it will raise).
    Repo.delete!(user)

    conn
      |> put_flash(:info, "User deleted successfully.")
      |> redirect(to: user_path(conn, :index))
  end

  defp validation(conn, user) do
      current_user = Session.current_user(conn)
      if current_user == nil || user == nil do
        redirectErrorPage(conn)
      end

      current_user_id = current_user.id
      case user.id do
        ^current_user_id -> true
        _ -> redirectErrorPage(conn)
      end
    end

    defp redirectErrorPage(conn) do
      conn
       |> put_flash(:error, "Upps, something went wrong!")
       |> redirect(to: page_path(conn, :index))
    end
end

web/views/user_view.ex
defmodule BachelorThesis.UserView do
  use BachelorThesis.Web, :view
end

web/templates/user/edit.html.eex
<h2>Edit user</h2>

<%= render "form.html", changeset: @changeset,
                        action: user_path(@conn, :update, @user) %>

<%= link "Back", to: user_path(@conn, :index) %>

web/templates/user/form.html.eex
<%= form_for @changeset, @action, fn f -> %>
  <%= if @changeset.action do %>
    <div class="alert alert-danger">
      <p>Oops, something went wrong! Please check the errors below.</p>
    </div>
  <% end %>

  <div class="form-group">
    <%= label f, :email, class: "control-label" %>
    <%= text_input f, :email, class: "form-control" %>
    <%= error_tag f, :email %>
  </div>

  <div class="form-group">
    <%= label f, :password, class: "control-label" %>
    <%= password_input f, :password, class: "form-control" %>
    <%= error_tag f, :password %>
  </div>

  <div class="form-group">
    <%= label f, :firstName, class: "control-label" %>
    <%= text_input f, :firstName, class: "form-control" %>
    <%= error_tag f, :firstName %>
  </div>

  <div class="form-group">
    <%= label f, :lastName, class: "control-label" %>
    <%= text_input f, :lastName, class: "form-control" %>
    <%= error_tag f, :lastName %>
  </div>

  <div class="form-group">
    <%= submit "Submit", class: "btn btn-primary" %>
  </div>
<% end %>

web/templates/user/index.html.eex
<h2>Listing users</h2>

<table class="table">
  <thead>
    <tr>
      <th>Email</th>
      <th>Password</th>
      <th>Firstname</th>
      <th>Lastname</th>
      <th>Admin</th>

      <th></th>
    </tr>
  </thead>
  <tbody>
<%= for user <- @users do %>
    <tr>
      <td><%= user.email %></td>
      <td><%= user.password %></td>
      <td><%= user.firstName %></td>
      <td><%= user.lastName %></td>
      <td><%= user.admin %></td>

      <td class="text-right">
        <%= link "Show", to: user_path(@conn, :show, user), class: "btn btn-default btn-xs" %>
        <%= link "Edit", to: user_path(@conn, :edit, user), class: "btn btn-default btn-xs" %>
        <%= link "Delete", to: user_path(@conn, :delete, user), method: :delete, data: [confirm: "Are you sure?"], class: "btn btn-danger btn-xs" %>
      </td>
    </tr>
<% end %>
  </tbody>
</table>

<%= link "New user", to: user_path(@conn, :new) %>

web/templates/user/new.html.eex
<h2>New user</h2>

<%= render "form.html", changeset: @changeset,
                        action: user_path(@conn, :create) %>

<%= link "Back", to: page_path(@conn, :index) %>

web/templates/user/show.html.eex
<h2>Hello <%= @user.firstName <> " " <> @user.lastName %></h2>
<ul>
  <li>
    <strong>Email:</strong>
    <%= @user.email %>
  </li>

  <li>
    <strong>Firstname:</strong>
    <%= @user.firstName %>
  </li>

  <li>
    <strong>Lastname:</strong>
    <%= @user.lastName %>
  </li>
</ul>


<h3>Smart devices</h3>
<table class="table">
  <thead>
  <tr>
    <th>Name</th>
    <th>Description</th>
    <th>Paired up</th>
    <th>Active</th>

    <th></th>
  </tr>
  </thead>
  <tbody>
  <%= for smart_device <- @user.smart_devices do %>
  <tr>
    <td><%= smart_device.name %></td>
    <td><%= smart_device.description %></td>
    <td><%= yesNo smart_device.pairedUp %></td>
    <td><%= yesNo smart_device.active %></td>

    <td class="text-right">
      <%= link "Show", to: user_smart_device_path(@conn, :show, @user, smart_device), class: "btn btn-default btn-xs" %>
      <%= link "Edit", to: user_smart_device_path(@conn, :edit, @user, smart_device), class: "btn btn-default btn-xs" %>
    </td>
  </tr>
  <% end %>
  </tbody>
</table>
<%= link "Add smart device", to: user_smart_device_path(@conn, :new, @user) %>



<h3>Devices</h3>
<table class="table">
  <thead>
  <tr>
    <th>Name</th>
    <th>Description</th>
    <th>Paired up</th>
    <th>Active</th>
    <th>Value</th>

    <th></th>
  </tr>
  </thead>
  <tbody>
  <%= for device <- @user.devices do %>
  <tr>
    <td><%= device.name %></td>
    <td><%= device.description %></td>
    <td><%= yesNo device.pairedUp %></td>
    <td><%= yesNo device.active %></td>
    <td><%= getDeviceValueByDevice device.id %></td>

    <td class="text-right">
      <%= link "Show", to: user_device_path(@conn, :show, @user, device), class: "btn btn-default btn-xs" %>
      <%= link "Edit", to: user_device_path(@conn, :edit, @user, device), class: "btn btn-default btn-xs" %>
    </td>
  </tr>
  <% end %>
  </tbody>
</table>
<%= link "Add device", to: user_device_path(@conn, :new, @user) %>